unit DemoUnit2;

interface

uses
  Windows, Messages, SysUtils, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, mwFastTime, mwPCharStream, mwPStringSort, Classes;

type
  TForm1 = class(TForm)
    btnLoad: TButton;
    edtTime: TEdit;
    edtItem: TEdit;
    btnFirst: TButton;
    btnPrevious: TButton;
    btnNext: TButton;
    btnLast: TButton;
    TrackBar1: TTrackBar;
    btnCombSort: TButton;
    OpenDialog1: TOpenDialog;
    Time1: TmwFastTime;
    btnClose: TButton;
    btnMergeSort: TButton;
    btnQuickSort: TButton;
    Label1: TLabel;
    procedure btnLoadClick(Sender: TObject);
    procedure LoadFile;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnFirstClick(Sender: TObject);
    procedure btnPreviousClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnLastClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure btnCombSortClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnMergeSortClick(Sender: TObject);
    procedure btnQuickSortClick(Sender: TObject);
  private
  protected
  public
  published
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var SorArray      : TPStringSort;
    PCharStream   : TPCharStream;
    SorArrayIndex : Integer;

procedure Display;
begin
  form1.edtItem.text := SorArray.Token[SorArrayIndex];
end;

procedure TForm1.LoadFile;
begin
  PcharStream:= TPcharStream.Create;
  PcharStream.LoadFromFile(OpenDialog1.FileName);
  SorArray.Tokenize(PcharStream.AsPchar, trunc(PcharStream.Size / 35));
  PCharStream.Free;
  form1.trackbar1.max := SorArray.Count-1;
  SorArrayindex := 0;
  Display;
end;



procedure TForm1.btnLoadClick(Sender: TObject);
begin
 if OpenDialog1.Execute then
 SorArray.Clear;
 Time1.Start;
 LoadFile;
 Time1.Stop;
 edtTime.text:= Time1.ElapsedTime;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SorArray := TPStringSort.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SorArray.Free;
end;

procedure TForm1.btnFirstClick(Sender: TObject);
begin
    SorArrayindex := 0;
    Display;
end;

procedure TForm1.btnPreviousClick(Sender: TObject);
begin
    if SorArrayindex > 0 then dec(SorArrayindex);
    Display;
end;

procedure TForm1.btnNextClick(Sender: TObject);
begin
    if SorArrayindex < SorArray.Count-1 then inc(SorArrayindex);
    Display;
end;

procedure TForm1.btnLastClick(Sender: TObject);
begin
    SorArrayindex := SorArray.count-1;
    Display;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
     SorArrayindex := trackbar1.position;
     Display;
end;

function Compare(Item1, Item2: PString): Integer;
begin
   Result:= AnsiCompareText(Item1^.Data, Item2^.Data);
end;

procedure TForm1.btnCombSortClick(Sender: TObject);
begin
   Time1.Start;
   SorArray.CombSortW(Compare);
   Time1.Stop;
   edtTime.Text:= Time1.ElapsedTime;
   Display;
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.btnMergeSortClick(Sender: TObject);
begin
   Time1.Start;
   SorArray.MergeSort(Compare);
   Time1.Stop;
   edtTime.Text:= Time1.ElapsedTime;
   Display;
end;

procedure TForm1.btnQuickSortClick(Sender: TObject);
begin
   Time1.Start;
   SorArray.QuickSort(Compare);
   Time1.Stop;
   edtTime.Text:= Time1.ElapsedTime;
   Display;
end;

end.
