unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mwDList, StdCtrls, mwFastTime;

type
  TForm1 = class(TForm)
    Load: TButton;
    Exit: TButton;
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    Edit4: TEdit;
    Time1: TmwFastTime;
    CheckBox1: TCheckBox;
    Sort: TButton;
    Save: TButton;
    Edit3: TEdit;
    CheckBox2: TCheckBox;
    Edit2: TEdit;
    DeleteEmptyNodes: TButton;
    Edit5: TEdit;
    First: TButton;
    Previous: TButton;
    Next: TButton;
    Last: TButton;
    Edit6: TEdit;
    List1: TmwDList;
    Label1: TLabel;
    procedure ExitClick(Sender: TObject);
    procedure LoadClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure SortClick(Sender: TObject);
    procedure DeleteEmptyNodesClick(Sender: TObject);
    procedure FirstClick(Sender: TObject);
    procedure LastClick(Sender: TObject);
    procedure PreviousClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
  private
    c, n1, n2: TLargeInteger;
    Time: ShortString;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.checked = True then
    begin
      List1.Reversed:= True;
    end
  else
    begin
      List1.Reversed:= False;
    end;
end;

procedure TForm1.LoadClick(Sender: TObject);
var
  FileName: String[255];
begin
  Edit1.Text:= '                             ';
  Edit2.Text:= '                             ';
  List1.free;
  List1:= TmwDlist.create(Self);
  if Opendialog1.Execute then begin
    FileName:=(OpenDialog1.FileName);
    Time1.Start;
    List1.LoadfromFile(FileName);
    Time1.Stop;
    Edit1.Text:= Time1.ElapsedTime;
    Edit2.Text:= IntToStr(List1.Size) + '  Items';
  end;
end;

procedure TForm1.SortClick(Sender: TObject);
begin
  Edit3.Text:= '                             ';
  if CheckBox2.checked = True then
    List1.IgnoreCase:= True else
    List1.IgnoreCase:= False;
    Time1.Start;
    List1.Sort;
    Time1.Stop;
    Edit3.Text:= Time1.ElapsedTime;
end;

procedure TForm1.SaveClick(Sender: TObject);
begin
  Edit4.Text:= '                             ';
  if CheckBox1.checked = True then
    List1.Reversed:= True else
    List1.Reversed:= False;
    Time1.Start;
    List1.SaveToFile('Output.txt');
    Time1.Stop;
    Edit4.Text:= Time1.ElapsedTime;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  close;
end;


procedure TForm1.DeleteEmptyNodesClick(Sender: TObject);
begin
  Time1.Start;
  List1.DeleteEmptyNodes;
  Time1.Stop;
  Edit2.Text:= IntToStr(List1.Size) + '  Items';
  Edit5.Text:= Time1.ElapsedTime;
end;

procedure TForm1.FirstClick(Sender: TObject);
begin
  List1.MoveFirst;
  Edit6.Text:= List1.GetData;
end;

procedure TForm1.LastClick(Sender: TObject);
begin
  List1.MoveLast;
  Edit6.Text:= List1.GetData;
end;

procedure TForm1.PreviousClick(Sender: TObject);
begin
  List1.MovePrevious;
  Edit6.Text:= List1.GetData;
end;

procedure TForm1.NextClick(Sender: TObject);
begin
  List1.MoveNext;
  Edit6.Text:= List1.GetData;
end;

end.
